

import java.io.*;
import java.util.*;

public class Data{
    
    private Map<String, List<Client>>files;

    public Data(){	
	files = new HashMap<String, List<Client>>();
    }

    
    public synchronized void remove(Client client){
	Set<String> set = files.keySet();
	List<Client> users;

	Iterator<String> itr = set.iterator();

	List<String> toBeRemoved = new ArrayList<String>();

	String str;
	
	while(itr.hasNext()){
	    str = itr.next();
	    users = files.get(str);

	    if(users.contains(client)){
		if(users.size() > 1)
		    users.remove(client);
		else
		    toBeRemoved.add(str);
	    }
	}

	itr = toBeRemoved.iterator();


	while(itr.hasNext())
	    files.remove(itr.next());       
    }
    

    public synchronized void put(String name, Client client){
	List<Client> user = files.get(name);

	//System.out.print("Inserting file <" + name + "> from client " + client.id);

	if(user == null){
	    //System.out.print(" first");
	    files.put(name, user = new ArrayList<Client>());
	}


	//System.out.println("");
       
	user.add(client);
    }

    public synchronized String getFiles(){
	String list = "";
	//System.out.println("Data. Building File List on Server");

	Set<String> keys = files.keySet();
	Iterator iter = keys.iterator();

	while(iter.hasNext())
	    list += "," + iter.next();
	
	
	    
	return list;
    }

    
    public synchronized List<Client> get(String name){
	return files.get(name);
    }
    

    public synchronized int size(){
	return files.size();
    }


}